// S2Air.cpp : Implementation of CS2Air
#include "stdafx.h"
#include "S2Air.h"

///////////////////////////////////////////////////
// CS2Air
//NrX
int FillMsg(char *src, char *target, int n)
{
	int i,len;
	len = strlen(target);
	for(i=0; i<len; i++)
		src[n++] = target[i];
	src[n++] = '\0';
	return(n);
}

/**********************************************************************
    : إ߻PSocket to AirAsuç@bKXˬd
  input : ServerIP   -> AIP
          ServerPort -> APort
	      UserID     -> b
          Passwd     -> KX
  output: ret -> ^нX
          ret= 0 : KX禨\,            ret= 1 : KX祢
          ret=-1 : initialize winsock fail, ret=-2 : Socket Create
          ret=-3 : Socket Connect,      ret=-4 : Socket Send 
		  ret=-5 : Socket Receive
***********************************************************************/
int CS2Air::StartCon(CString ServerIP, CString ServerPort, CString UserID, CString Passwd, CString *pVal)
{
	// TODO: Add your implementation code here

	short ret=-1;     //^ǭ
	CString ret_data; //^Ǧr
	int iPos=0;
	WSADATA WSAData;
	struct sockaddr_in servAddr;
	clientSD = -1;

	UINT M_ServerPort = atoi(ServerPort); //NCString নUINT

	memset((char *)&servAddr, 0, sizeof(servAddr));
	servAddr.sin_family = AF_INET;
	servAddr.sin_addr.s_addr = inet_addr(ServerIP);
	servAddr.sin_port = htons(M_ServerPort);


	if (WSAStartup((WORD)((1 << 8) | 1), (LPWSADATA)&WSAData)!=0) {
		ret=-1; // Initialize the Winsock() error
		ret_data.Format("%s","Initialize the Winsock Error!");
		*pVal = ret_data;
		return ret;
	}

	if((clientSD = socket(AF_INET, SOCK_STREAM, 0)) == INVALID_SOCKET){
		EndCon();
		ret=-2; //Socket Create
		ret_data.Format("%s","Socket Create Error!");
		*pVal = ret_data;
		return ret;  
	}

	if(connect(clientSD, (struct sockaddr far *)&servAddr, sizeof(servAddr)) !=0){
		EndCon();
		ret=-3; //Socket Connect
		ret_data.Format("%s","Socket Connect Error!");
		*pVal = ret_data;
		return ret;  
	}

	//ˬdUsername,Pwb/KX
	memset((char *)&sendMsg, 0, sizeof(sendMsg));
	sendMsg.interface_type = INTERFACE_TYPE;
	sendMsg.msg_type = 0;
	iPos = 0;				
											//NCStringনchar array
	iPos = FillMsg(&sendMsg.msg_content[0], UserID.GetBuffer(UserID.GetLength()), iPos);
	iPos = FillMsg(&sendMsg.msg_content[0], Passwd.GetBuffer(Passwd.GetLength()), iPos);
	sendMsg.msg_content_len = iPos;

	//ǰe
	if(send(clientSD, (char *)&sendMsg, sizeof(sendMsg), 0) == SOCKET_ERROR){
		EndCon();
		ret=-4; //Socket Send 
		ret_data.Format("%s","Socket Send Data Error!");
		*pVal = ret_data;
		return ret;  
	}

	memset((char *)&retMsg, 0, sizeof(retMsg));	
	//
	int result = recv(clientSD, (char *)&retMsg, sizeof(retMsg), 0);
	if((result == SOCKET_ERROR) || (result <= 0)){
		EndCon();
		ret=-5; //Socket Receive
		ret_data.Format("%s","Socket Receive Data Error!");
		*pVal = ret_data;
		return ret;  
	}

	//KX禨\
	if(retMsg.ret_code == 0){
		ret=0;
		ret_data.Format("%s",retMsg.ret_description);
		*pVal = ret_data;
	}
	else{ 	//KX祢
		ret=1;
		ret_data.Format("%s",retMsg.ret_description);
		*pVal = ret_data;
	}
	
    return ret;  
}

/**********************************************************************
    : ǰe²Te
  input : MobileNum -> X
          Message   -> Te
	      Send_Time -> ǰeɶ
		  *pVal		-> ^Ǧr
  output: ret -> ret_code,			pVal -> ret_description
          ret= 0 : ǰe\			ret!=0  : ǰe
		  ret=-4 : Socket Send  ret=-5 : Socket Receive
***********************************************************************/
int CS2Air::SendMsg(CString MobileNum, CString Message, short Send_Type, CString Send_Time, CString *pVal)
{
	// TODO: Add your implementation code here
	int iPos;
	CString MessageID; //ǰe^ǪMessageID

	
	// ǰeT
	memset((char *)&sendMsg, 0, sizeof(sendMsg));
	sendMsg.interface_type = INTERFACE_TYPE;
	sendMsg.msg_type = 1;
	iPos = 0;
											//NCStringনchar array
	iPos = FillMsg(&sendMsg.msg_content[0], MobileNum.GetBuffer(MobileNum.GetLength()), iPos);
	iPos = FillMsg(&sendMsg.msg_content[0], Message.GetBuffer(Message.GetLength()), iPos);
	sendMsg.msg_content[iPos++] = (char)Send_Type;	//]wǰeA
	sendMsg.msg_content[iPos++] = '\0';
	iPos = FillMsg(&sendMsg.msg_content[0], Send_Time.GetBuffer(Send_Time.GetLength()), iPos);
	sendMsg.msg_content[iPos++] = '\0';
	sendMsg.msg_content_len = iPos;

	//ǰe
	if(send(clientSD, (char *)&sendMsg, sizeof(sendMsg), 0) == SOCKET_ERROR){
		EndCon();
		MessageID.Format("%s","socket send error!");
		*pVal = MessageID;
		return -4;
	}


	memset((char *)&retMsg, 0, sizeof(retMsg));	
	//
	int result = recv(clientSD, (char *)&retMsg, sizeof(retMsg), 0);
	if((result == SOCKET_ERROR) || (result <= 0)){
		EndCon();
		MessageID.Format("%s","socket receive error!");
		*pVal = MessageID.AllocSysString();
		return -5;
	}

	//Nrȳ]pValApVal^ǭ
	MessageID.Format("%s",retMsg.ret_description);
	*pVal = MessageID.AllocSysString();

	return retMsg.ret_code;
}

/**********************************************************************
    : d²TǰeG
  input : MobileNum -> X
          MessageID -> TID
	      *pVal		-> ^Ǧr
  output: ret -> ret_code,			pVal -> ret_description
		  ret=-4 : Socket Send ,ret=-5 : Socket Receive
***********************************************************************/
int CS2Air::SendQuery(CString MobileNum, CString MessageID, CString *pVal)
{
	// TODO: Add your implementation code here
	short ret=0; //^ǭܼ
	int iPos;

	CString Result;

	// ǰeT
	memset((char *)&sendMsg, 0, sizeof(sendMsg));
	sendMsg.interface_type = INTERFACE_TYPE;
	sendMsg.msg_type = 2;
	iPos = 0;
											//NCStringনchar array
	iPos = FillMsg(&sendMsg.msg_content[0], MobileNum.GetBuffer(MobileNum.GetLength()), iPos);
	iPos = FillMsg(&sendMsg.msg_content[0], MessageID.GetBuffer(MessageID.GetLength()), iPos);
	sendMsg.msg_content_len = iPos;

	//ǰe
	if(send(clientSD, (char *)&sendMsg, sizeof(sendMsg), 0) == SOCKET_ERROR){
		EndCon();
		ret=-4; //socket Send 
		Result.Format("%s","socket send error!");
		*pVal = Result.AllocSysString();
		return -4;
	}

	memset((char *)&retMsg, 0, sizeof(retMsg));	
	//
	int result = recv(clientSD, (char *)&retMsg, sizeof(retMsg), 0);
	if((result == SOCKET_ERROR) || (result <= 0)){
		EndCon();
		ret=-5; //socket Reveice 
		Result.Format("%s","socket receive error!");
		*pVal = Result.AllocSysString();
		return -5;
	}

	//Nrȳ]pValApVal^ǭ
	Result.Format("%s",retMsg.ret_description);
	*pVal = Result.AllocSysString();

	return retMsg.ret_code;
}


//PSocket to AirAsu
void CS2Air::EndCon()
{
	// TODO: Add your implementation code here
	shutdown(clientSD, 0);  // clientSD cannot send anymore 
	closesocket(clientSD);   // close socket()
	WSACleanup(); 
}

